/*
 * FtpControlSocket.java
 *
 * Created on 10 novembre 2006, 11:18
 *
 */

package com.ewon.ewonlib.ftpclient;

import javax.microedition.io.*;
import java.io.*;

/**
 *
 * @author ahe
 */

class FtpControlSocket  {
    
    /** Creates a new instance of FtpControlSocket */
    public FtpControlSocket() {
    }
    
    public void open(String openParm) throws FtpCException, IOException{
       if (sc != null) {
          throw new FtpCException("Ftp Control Socket already open");    
       }
       try {
          sc = (SocketConnection) Connector.open(openParm);
          is = sc.openInputStream();
          os = sc.openOutputStream();  
       }  catch (IOException  ex) {
          close();
          throw ex;
       }
    }
    public void write(byte[] bytes) throws FtpCException,IOException {
       if (sc == null)  {
          throw new FtpCException("Ftp Control Socket not open");
        }
        try {
          os.write(bytes);   
        } catch (IOException  ex) {
           close();
           throw ex;
        }    
    }
    public int  read(byte[]  bytes) throws FtpCException,IOException {
        int bytesRead;
        if (sc == null)  {
           throw new FtpCException("Ftp Control Socket not open");
        }
        try {
           bytesRead = is.read(bytes);   
        } catch (IOException  ex) {
           close();
           throw ex;
        }
        return bytesRead;
    }
    
    public int  read() throws FtpCException,IOException {
        int byteRead;
        if (sc == null)  {
           throw new FtpCException("Ftp Control Socket not open");
        }
        try {
           byteRead = is.read();   
        } catch (IOException  ex) {
           close();
           throw ex;
        }
        return byteRead;
    } 
    
    public String getLocalAddress() throws FtpCException,IOException {
        if (sc == null)  {
           throw new FtpCException("Ftp Control Socket not open");
        }    
        try {
           return (sc.getLocalAddress());
        } catch (IOException  ex) {
            close();
            throw ex;
        }
    }
    public void close() throws IOException {
       if (os != null) {
              os.close();
              os = null;
       }
       if (is != null) {
           is.close();
           is = null;
       }
       if (sc != null) {
          sc.close();
          sc = null;
       }
    }

    private SocketConnection  sc = null;
    private InputStream       is = null;
    private OutputStream      os = null;
    
}
