/*
 * FtpDataSocket.java
 *
 * Created on 10 novembre 2006, 12:19
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.ewon.ewonlib.ftpclient;

import javax.microedition.io.*;
import java.io.*;

/**
 * 
 * @author ahe
 */
class FtpDataSocket {
    
    /** Creates a new instance of FtpDataSocket */
    public FtpDataSocket() {
    }
    
    public void openActive(String openParm) throws FtpCException,IOException{
       if (server != null) {
          throw new FtpCException("Ftp Data Socket already open");    
       }
       try {
           server = (ServerSocketConnection) Connector.open(openParm); 
       }  catch (IOException  ex) {
          close();
          throw ex;    
       }
    }
    
    public void acceptActive() throws FtpCException,IOException{
       if (sc != null) {
          throw new FtpCException("Ftp Data Socket already open");    
       }
       try {

           sc = (SocketConnection) server.acceptAndOpen(); 
           is = sc.openInputStream();
           os = sc.openOutputStream();  
       }  catch (IOException  ex) {
          close();
          throw ex;    
       }
    }
    
    public void openPassive(String openParm) throws FtpCException,IOException{
       if (sc != null) {
          throw new FtpCException("Ftp Data Socket already open");    
       }
       try {
          sc = (SocketConnection) Connector.open(openParm);
          is = sc.openInputStream();
          os = sc.openOutputStream();  
       }  catch (IOException  ex) {
          close();
          throw ex;    
       }
    }
    
    public void write(byte[] bytes) throws FtpCException,IOException {
       if (sc == null)  {
            throw new IOException("Ftp Data Socket not open");
        }
        try {
            os.write(bytes);   
        } catch (IOException  ex) {
          close();
          throw ex;       
        }    
    }
    
    public void write(byte[] bytes,int off,int len) throws FtpCException,IOException {
       if (sc == null)  {
            throw new FtpCException("Ftp Data Socket not open");
        }
        try {
            os.write(bytes,off,len);   
        } catch (IOException  ex) {
          close();
          throw ex;       
        }    
    }
    public int  read() throws FtpCException,IOException {
        int byteRead;
        if (sc == null)  {
            throw new FtpCException("Ftp Data Socket not open");
        }
        try {
            byteRead = is.read();   
        } catch (IOException  ex) {
          close();
          throw ex;       
        }
        return byteRead;
    }
    public int  read(byte[]  bytes) throws FtpCException,IOException {
        int bytesRead;
        if (sc == null)  {
            throw new FtpCException("Ftp Data Socket not open");
        }
        try {
            bytesRead = is.read(bytes);   
        } catch (IOException  ex) {
          close();
          throw ex;       
        }
        return bytesRead;
    }
    
    public int  read(byte[]  bytes, int off, int len) throws FtpCException,IOException {
       int bytesRead;
        if (sc == null)  {
            throw new FtpCException("Ftp Data Socket not open");
        }
        try {
            bytesRead = is.read(bytes,off,len);   
        } catch (IOException  ex) {
          close();
          throw ex;       
        }
        return bytesRead;
    }
    
     public void close() throws FtpCException,IOException {
       if (os != null) {
              os.close();
              os = null;
       }
       if (is != null) {
           is.close();
           is = null;
       }
       if (sc != null) {
          sc.close();
          sc = null;
       }
       if (server != null) {
           server.close();
           server = null;
       }
    }

  
    SocketConnection         sc     = null;
    ServerSocketConnection   server = null;
    InputStream              is     = null;
    OutputStream             os     = null;  
}
